Index: uspace/lib/usbdev/src/recognise.c
===================================================================
--- uspace/lib/usbdev/src/recognise.c	(revision f3a37e28da7ac61dc36eddfe4c920641264b4500)
+++ uspace/lib/usbdev/src/recognise.c	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
@@ -33,4 +33,7 @@
  * Functions for recognition of attached devices.
  */
+
+/** XXX Fix this */
+#define _DDF_DATA_IMPLANT
 
 #include <sys/types.h>
@@ -352,9 +355,10 @@
 	
 	if (dev_ops != NULL)
-		child->ops = dev_ops;
+		ddf_fun_set_ops(child, dev_ops);
 	else
-		child->ops = &child_ops;
-	
-	child->driver_data = dev_data;
+		ddf_fun_set_ops(child, &child_ops);
+	
+	ddf_fun_data_implant(child, dev_data);
+	
 	/*
 	 * Store the attached device in fun
@@ -373,7 +377,20 @@
 	}
 	
-	rc = usb_device_create_match_ids(ctrl_pipe, &child->match_ids);
+	match_id_list_t match_ids;
+	init_match_ids(&match_ids);
+	rc = usb_device_create_match_ids(ctrl_pipe, &match_ids);
 	if (rc != EOK)
 		goto failure;
+	
+	list_foreach(match_ids.ids, id_link) {
+		match_id_t *match_id = list_get_instance(id_link, match_id_t, link);
+		rc = ddf_fun_add_match_id(child, match_id->id, match_id->score);
+		if (rc != EOK) {
+			clean_match_ids(&match_ids);
+			goto failure;
+		}
+	}
+	
+	clean_match_ids(&match_ids);
 	
 	rc = ddf_fun_bind(child);
@@ -386,8 +403,4 @@
 failure:
 	if (child != NULL) {
-		/* We know nothing about the data if it came from outside. */
-		if (dev_data)
-			child->driver_data = NULL;
-		
 		/* This takes care of match_id deallocation as well. */
 		ddf_fun_destroy(child);
Index: uspace/lib/usbhost/include/usb/host/hcd.h
===================================================================
--- uspace/lib/usbhost/include/usb/host/hcd.h	(revision f3a37e28da7ac61dc36eddfe4c920641264b4500)
+++ uspace/lib/usbhost/include/usb/host/hcd.h	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
@@ -98,8 +98,7 @@
  * @return pointer cast to hcd_t*.
  */
-static inline hcd_t * fun_to_hcd(const ddf_fun_t *fun)
+static inline hcd_t *fun_to_hcd(ddf_fun_t *fun)
 {
-	assert(fun);
-	return fun->driver_data;
+	return ddf_fun_data_get(fun);
 }
 
Index: uspace/srv/bd/part/guid_part/guid_part.c
===================================================================
--- uspace/srv/bd/part/guid_part/guid_part.c	(revision f3a37e28da7ac61dc36eddfe4c920641264b4500)
+++ uspace/srv/bd/part/guid_part/guid_part.c	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
@@ -55,5 +55,5 @@
 #include <sys/typefmt.h>
 #include <inttypes.h>
-#include <libblock.h>
+#include <block.h>
 #include <loc.h>
 #include <errno.h>
Index: uspace/srv/bd/part/mbr_part/mbr_part.c
===================================================================
--- uspace/srv/bd/part/mbr_part/mbr_part.c	(revision f3a37e28da7ac61dc36eddfe4c920641264b4500)
+++ uspace/srv/bd/part/mbr_part/mbr_part.c	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
@@ -65,5 +65,5 @@
 #include <sys/typefmt.h>
 #include <inttypes.h>
-#include <libblock.h>
+#include <block.h>
 #include <errno.h>
 #include <bool.h>
Index: uspace/srv/fs/cdfs/cdfs_ops.c
===================================================================
--- uspace/srv/fs/cdfs/cdfs_ops.c	(revision f3a37e28da7ac61dc36eddfe4c920641264b4500)
+++ uspace/srv/fs/cdfs/cdfs_ops.c	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
@@ -44,5 +44,5 @@
 #include <libfs.h>
 #include <errno.h>
-#include <libblock.h>
+#include <block.h>
 #include <str.h>
 #include <byteorder.h>
Index: uspace/srv/fs/exfat/exfat_bitmap.c
===================================================================
--- uspace/srv/fs/exfat/exfat_bitmap.c	(revision f3a37e28da7ac61dc36eddfe4c920641264b4500)
+++ uspace/srv/fs/exfat/exfat_bitmap.c	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
@@ -39,5 +39,5 @@
 #include "../../vfs/vfs.h"
 #include <libfs.h>
-#include <libblock.h>
+#include <block.h>
 #include <errno.h>
 #include <byteorder.h>
Index: uspace/srv/fs/exfat/exfat_directory.c
===================================================================
--- uspace/srv/fs/exfat/exfat_directory.c	(revision f3a37e28da7ac61dc36eddfe4c920641264b4500)
+++ uspace/srv/fs/exfat/exfat_directory.c	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
@@ -39,5 +39,5 @@
 #include "exfat_directory.h"
 #include "exfat_fat.h"
-#include <libblock.h>
+#include <block.h>
 #include <errno.h>
 #include <byteorder.h>
Index: uspace/srv/fs/exfat/exfat_fat.c
===================================================================
--- uspace/srv/fs/exfat/exfat_fat.c	(revision f3a37e28da7ac61dc36eddfe4c920641264b4500)
+++ uspace/srv/fs/exfat/exfat_fat.c	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
@@ -42,5 +42,5 @@
 #include "../../vfs/vfs.h"
 #include <libfs.h>
-#include <libblock.h>
+#include <block.h>
 #include <errno.h>
 #include <byteorder.h>
Index: uspace/srv/fs/exfat/exfat_fat.h
===================================================================
--- uspace/srv/fs/exfat/exfat_fat.h	(revision f3a37e28da7ac61dc36eddfe4c920641264b4500)
+++ uspace/srv/fs/exfat/exfat_fat.h	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
@@ -37,5 +37,5 @@
 #include "../../vfs/vfs.h"
 #include <stdint.h>
-#include <libblock.h>
+#include <block.h>
 
 #define EXFAT_ROOT_IDX		0
Index: uspace/srv/fs/exfat/exfat_ops.c
===================================================================
--- uspace/srv/fs/exfat/exfat_ops.c	(revision f3a37e28da7ac61dc36eddfe4c920641264b4500)
+++ uspace/srv/fs/exfat/exfat_ops.c	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
@@ -45,5 +45,5 @@
 #include "../../vfs/vfs.h"
 #include <libfs.h>
-#include <libblock.h>
+#include <block.h>
 #include <ipc/services.h>
 #include <ipc/loc.h>
Index: uspace/srv/fs/ext2fs/ext2fs_ops.c
===================================================================
--- uspace/srv/fs/ext2fs/ext2fs_ops.c	(revision f3a37e28da7ac61dc36eddfe4c920641264b4500)
+++ uspace/srv/fs/ext2fs/ext2fs_ops.c	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
@@ -39,5 +39,5 @@
 #include "../../vfs/vfs.h"
 #include <libfs.h>
-#include <libblock.h>
+#include <block.h>
 #include <libext2.h>
 #include <ipc/services.h>
Index: uspace/srv/fs/fat/fat_directory.c
===================================================================
--- uspace/srv/fs/fat/fat_directory.c	(revision f3a37e28da7ac61dc36eddfe4c920641264b4500)
+++ uspace/srv/fs/fat/fat_directory.c	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
@@ -38,5 +38,5 @@
 #include "fat_directory.h"
 #include "fat_fat.h"
-#include <libblock.h>
+#include <block.h>
 #include <errno.h>
 #include <byteorder.h>
Index: uspace/srv/fs/fat/fat_fat.c
===================================================================
--- uspace/srv/fs/fat/fat_fat.c	(revision f3a37e28da7ac61dc36eddfe4c920641264b4500)
+++ uspace/srv/fs/fat/fat_fat.c	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
@@ -42,5 +42,5 @@
 #include "../../vfs/vfs.h"
 #include <libfs.h>
-#include <libblock.h>
+#include <block.h>
 #include <errno.h>
 #include <byteorder.h>
Index: uspace/srv/fs/fat/fat_fat.h
===================================================================
--- uspace/srv/fs/fat/fat_fat.h	(revision f3a37e28da7ac61dc36eddfe4c920641264b4500)
+++ uspace/srv/fs/fat/fat_fat.h	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
@@ -37,5 +37,5 @@
 #include "../../vfs/vfs.h"
 #include <stdint.h>
-#include <libblock.h>
+#include <block.h>
 
 #define FAT1		0
Index: uspace/srv/fs/fat/fat_ops.c
===================================================================
--- uspace/srv/fs/fat/fat_ops.c	(revision f3a37e28da7ac61dc36eddfe4c920641264b4500)
+++ uspace/srv/fs/fat/fat_ops.c	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
@@ -43,5 +43,5 @@
 #include "../../vfs/vfs.h"
 #include <libfs.h>
-#include <libblock.h>
+#include <block.h>
 #include <ipc/services.h>
 #include <ipc/loc.h>
Index: uspace/srv/fs/mfs/mfs.h
===================================================================
--- uspace/srv/fs/mfs/mfs.h	(revision f3a37e28da7ac61dc36eddfe4c920641264b4500)
+++ uspace/srv/fs/mfs/mfs.h	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
@@ -36,5 +36,5 @@
 #include <minix.h>
 #include <macros.h>
-#include <libblock.h>
+#include <block.h>
 #include <libfs.h>
 #include <adt/list.h>
Index: uspace/srv/fs/tmpfs/tmpfs_dump.c
===================================================================
--- uspace/srv/fs/tmpfs/tmpfs_dump.c	(revision f3a37e28da7ac61dc36eddfe4c920641264b4500)
+++ uspace/srv/fs/tmpfs/tmpfs_dump.c	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
@@ -44,5 +44,5 @@
 #include <sys/types.h>
 #include <as.h>
-#include <libblock.h>
+#include <block.h>
 #include <byteorder.h>
 
Index: uspace/srv/hid/compositor/Makefile
===================================================================
--- uspace/srv/hid/compositor/Makefile	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
+++ uspace/srv/hid/compositor/Makefile	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
@@ -0,0 +1,49 @@
+#
+# Copyright (c) 2012 Petr Koupy
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+#
+# - Redistributions of source code must retain the above copyright
+#   notice, this list of conditions and the following disclaimer.
+# - Redistributions in binary form must reproduce the above copyright
+#   notice, this list of conditions and the following disclaimer in the
+#   documentation and/or other materials provided with the distribution.
+# - The name of the author may not be used to endorse or promote products
+#   derived from this software without specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+#
+
+USPACE_PREFIX = ../../..
+LIBS = $(LIBDRAW_PREFIX)/libdraw.a $(LIBSOFTREND_PREFIX)/libsoftrend.a \
+	$(LIBSOFTFLOAT_PREFIX)/libsoftfloat.a
+EXTRA_CFLAGS += -I$(LIBDRAW_PREFIX) -I$(LIBSOFTREND_PREFIX)
+BINARY = compositor
+
+SOURCES = \
+	compositor.c \
+	images.c
+
+IMAGES = \
+	gfx/helenos.tga \
+	gfx/nameic.tga
+
+PRE_DEPEND = images.c images.h
+EXTRA_CLEAN = images.c images.h
+
+include $(USPACE_PREFIX)/Makefile.common
+
+images.c images.h: $(IMAGES)
+	$(ROOT_PATH)/tools/mkarray.py images COMPOSITOR_IMAGES $^
